Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4671)
@@ -5975,9 +6088,9 @@
           CASE ( 't_soil' )
              IF ( ALLOCATED( t_soil_av ) ) THEN
-                DO  m = 1, surf_lsm_h%ns
-                   i   = surf_lsm_h%i(m)
-                   j   = surf_lsm_h%j(m)
+                DO  m = 1, surf_lsm_h(0)%ns
+                   i   = surf_lsm_h(0)%i(m)
+                   j   = surf_lsm_h(0)%j(m)
                    DO  k = nzb_soil, nzt_soil
-                      t_soil_av(k,j,i) = t_soil_av(k,j,i) + t_soil_h%var_2d(k,m)
+                      t_soil_av(k,j,i) = t_soil_av(k,j,i) + t_soil_h(0)%var_2d(k,m)
                    ENDDO
                 ENDDO
@@ -6196,8 +6309,8 @@
        CASE ( 'c_liq*_xy' )        ! 2d-array
           IF ( av == 0 )  THEN
-             DO  m = 1, surf_lsm_h%ns
-                i                   = surf_lsm_h%i(m)
-                j                   = surf_lsm_h%j(m)
-                local_pf(i,j,nzb+1) = surf_lsm_h%c_liq(m) * surf_lsm_h%c_veg(m)
+             DO  m = 1, surf_lsm_h(0)%ns
+                i                   = surf_lsm_h(0)%i(m)
+                j                   = surf_lsm_h(0)%j(m)
+                local_pf(i,j,nzb+1) = surf_lsm_h(0)%c_liq(m) * surf_lsm_h(0)%c_veg(m)
              ENDDO
           ELSE
@@ -6218,8 +6331,8 @@
        CASE ( 'c_soil*_xy' )        ! 2d-array
           IF ( av == 0 )  THEN
-             DO  m = 1, surf_lsm_h%ns
-                i                   = surf_lsm_h%i(m)
-                j                   = surf_lsm_h%j(m)
-                local_pf(i,j,nzb+1) = 1.0_wp - surf_lsm_h%c_veg(m)
+             DO  m = 1, surf_lsm_h(0)%ns
+                i                   = surf_lsm_h(0)%i(m)
+                j                   = surf_lsm_h(0)%j(m)
+                local_pf(i,j,nzb+1) = 1.0_wp - surf_lsm_h(0)%c_veg(m)
              ENDDO
           ELSE
@@ -6240,8 +6353,8 @@
        CASE ( 'c_veg*_xy' )        ! 2d-array
           IF ( av == 0 )  THEN
-             DO  m = 1, surf_lsm_h%ns
-                i                   = surf_lsm_h%i(m)
-                j                   = surf_lsm_h%j(m)
-                local_pf(i,j,nzb+1) = surf_lsm_h%c_veg(m)
+             DO  m = 1, surf_lsm_h(0)%ns
+                i                   = surf_lsm_h(0)%i(m)
+                j                   = surf_lsm_h(0)%j(m)
+                local_pf(i,j,nzb+1) = surf_lsm_h(0)%c_veg(m)
              ENDDO
           ELSE
@@ -6262,8 +6375,8 @@
        CASE ( 'lai*_xy' )        ! 2d-array
           IF ( av == 0 )  THEN
-             DO  m = 1, surf_lsm_h%ns
-                i                   = surf_lsm_h%i(m)
-                j                   = surf_lsm_h%j(m)
-                local_pf(i,j,nzb+1) = surf_lsm_h%lai(m)
+             DO  m = 1, surf_lsm_h(0)%ns
+                i                   = surf_lsm_h(0)%i(m)
+                j                   = surf_lsm_h(0)%j(m)
+                local_pf(i,j,nzb+1) = surf_lsm_h(0)%lai(m)
              ENDDO
           ELSE
@@ -6284,8 +6397,8 @@
        CASE ( 'm_liq*_xy' )        ! 2d-array
           IF ( av == 0 )  THEN
-             DO  m = 1, surf_lsm_h%ns
-                i                   = surf_lsm_h%i(m)
-                j                   = surf_lsm_h%j(m)
-                local_pf(i,j,nzb+1) = m_liq_h%var_1d(m)
+             DO  m = 1, surf_lsm_h(0)%ns
+                i                   = surf_lsm_h(0)%i(m)
+                j                   = surf_lsm_h(0)%j(m)
+                local_pf(i,j,nzb+1) = m_liq_h(0)%var_1d(m)
              ENDDO
           ELSE
@@ -6306,9 +6419,9 @@
        CASE ( 'm_soil_xy', 'm_soil_xz', 'm_soil_yz' )
           IF ( av == 0 )  THEN
-             DO  m = 1, surf_lsm_h%ns
-                i   = surf_lsm_h%i(m)
-                j   = surf_lsm_h%j(m)
+             DO  m = 1, surf_lsm_h(0)%ns
+                i   = surf_lsm_h(0)%i(m)
+                j   = surf_lsm_h(0)%j(m)
                 DO k = nzb_soil, nzt_soil
-                   local_pf(i,j,k) = m_soil_h%var_2d(k,m)
+                   local_pf(i,j,k) = m_soil_h(0)%var_2d(k,m)
                 ENDDO
              ENDDO
@@ -6334,8 +6447,8 @@
        CASE ( 'qsws_liq*_xy' )        ! 2d-array
           IF ( av == 0 ) THEN
-             DO  m = 1, surf_lsm_h%ns
-                i                   = surf_lsm_h%i(m)
-                j                   = surf_lsm_h%j(m)
-                local_pf(i,j,nzb+1) = surf_lsm_h%qsws_liq(m)
+             DO  m = 1, surf_lsm_h(0)%ns
+                i                   = surf_lsm_h(0)%i(m)
+                j                   = surf_lsm_h(0)%j(m)
+                local_pf(i,j,nzb+1) = surf_lsm_h(0)%qsws_liq(m)
              ENDDO
           ELSE
@@ -6356,8 +6469,8 @@
        CASE ( 'qsws_soil*_xy' )        ! 2d-array
           IF ( av == 0 ) THEN
-             DO  m = 1, surf_lsm_h%ns
-                i                   = surf_lsm_h%i(m)
-                j                   = surf_lsm_h%j(m)
-                local_pf(i,j,nzb+1) =  surf_lsm_h%qsws_soil(m)
+             DO  m = 1, surf_lsm_h(0)%ns
+                i                   = surf_lsm_h(0)%i(m)
+                j                   = surf_lsm_h(0)%j(m)
+                local_pf(i,j,nzb+1) =  surf_lsm_h(0)%qsws_soil(m)
              ENDDO
           ELSE
@@ -6378,8 +6491,8 @@
        CASE ( 'qsws_veg*_xy' )        ! 2d-array
           IF ( av == 0 ) THEN
-             DO  m = 1, surf_lsm_h%ns
-                i                   = surf_lsm_h%i(m)
-                j                   = surf_lsm_h%j(m)
-                local_pf(i,j,nzb+1) =  surf_lsm_h%qsws_veg(m)
+             DO  m = 1, surf_lsm_h(0)%ns
+                i                   = surf_lsm_h(0)%i(m)
+                j                   = surf_lsm_h(0)%j(m)
+                local_pf(i,j,nzb+1) =  surf_lsm_h(0)%qsws_veg(m)
              ENDDO
           ELSE
@@ -6401,8 +6514,8 @@
        CASE ( 'r_s*_xy' )        ! 2d-array
           IF ( av == 0 )  THEN
-             DO  m = 1, surf_lsm_h%ns
-                i                   = surf_lsm_h%i(m)
-                j                   = surf_lsm_h%j(m)
-                local_pf(i,j,nzb+1) = surf_lsm_h%r_s(m)
+             DO  m = 1, surf_lsm_h(0)%ns
+                i                   = surf_lsm_h(0)%i(m)
+                j                   = surf_lsm_h(0)%j(m)
+                local_pf(i,j,nzb+1) = surf_lsm_h(0)%r_s(m)
              ENDDO
           ELSE
@@ -6423,9 +6536,9 @@
        CASE ( 't_soil_xy', 't_soil_xz', 't_soil_yz' )
           IF ( av == 0 )  THEN
-             DO  m = 1, surf_lsm_h%ns
-                i   = surf_lsm_h%i(m)
-                j   = surf_lsm_h%j(m)
+             DO  m = 1, surf_lsm_h(0)%ns
+                i   = surf_lsm_h(0)%i(m)
+                j   = surf_lsm_h(0)%j(m)
                 DO k = nzb_soil, nzt_soil
-                   local_pf(i,j,k) = t_soil_h%var_2d(k,m)
+                   local_pf(i,j,k) = t_soil_h(0)%var_2d(k,m)
                 ENDDO
              ENDDO
@@ -6498,9 +6611,9 @@
 
          IF ( av == 0 )  THEN
-            DO  m = 1, surf_lsm_h%ns
-                i   = surf_lsm_h%i(m)
-                j   = surf_lsm_h%j(m)
+            DO  m = 1, surf_lsm_h(0)%ns
+                i   = surf_lsm_h(0)%i(m)
+                j   = surf_lsm_h(0)%j(m)
                 DO  k = nzb_soil, nzt_soil
-                   local_pf(i,j,k) = m_soil_h%var_2d(k,m)
+                   local_pf(i,j,k) = m_soil_h(0)%var_2d(k,m)
                 ENDDO
             ENDDO
@@ -6522,9 +6635,9 @@
 
          IF ( av == 0 )  THEN
-            DO  m = 1, surf_lsm_h%ns
-               i   = surf_lsm_h%i(m)
-               j   = surf_lsm_h%j(m)
+            DO  m = 1, surf_lsm_h(0)%ns
+               i   = surf_lsm_h(0)%i(m)
+               j   = surf_lsm_h(0)%j(m)
                DO  k = nzb_soil, nzt_soil
-                  local_pf(i,j,k) = t_soil_h%var_2d(k,m)
+                  local_pf(i,j,k) = t_soil_h(0)%var_2d(k,m)
                ENDDO
             ENDDO
@@ -6577,5 +6690,5 @@
 
        CALL wrd_write_string( 'ns_h_on_file_lsm' )
-       WRITE ( 14 )  surf_lsm_h%ns
+       WRITE ( 14 )  surf_lsm_h(0:1)%ns
 
        CALL wrd_write_string( 'ns_v_on_file_lsm' )
@@ -6633,12 +6746,15 @@
        ENDIF
 
-       CALL wrd_write_string( 'lsm_start_index_h' )
-       WRITE ( 14 )  surf_lsm_h%start_index
-
-       CALL wrd_write_string( 'lsm_end_index_h' )
-       WRITE ( 14 )  surf_lsm_h%end_index
-
-       CALL wrd_write_string( 't_soil_h' )
-       WRITE ( 14 )  t_soil_h%var_2d
+       DO  l = 0, 1
+          CALL wrd_write_string( 'lsm_start_index_h' )
+          WRITE ( 14 )  surf_lsm_h(l)%start_index
+
+          CALL wrd_write_string( 'lsm_end_index_h' )
+          WRITE ( 14 )  surf_lsm_h(l)%end_index
+
+          WRITE( dum, '(I1)')  l
+          CALL wrd_write_string( 't_soil_h(' // dum // ')' )
+          WRITE ( 14 )  t_soil_h(l)%var_2d
+       ENDDO
 
        DO  l = 0, 3
@@ -6656,12 +6772,15 @@
        ENDDO
 
-       CALL wrd_write_string( 'lsm_start_index_h' )
-       WRITE ( 14 )  surf_lsm_h%start_index
-
-       CALL wrd_write_string( 'lsm_end_index_h' )
-       WRITE ( 14 )  surf_lsm_h%end_index
-
-       CALL wrd_write_string( 'm_soil_h' )
-       WRITE ( 14 )  m_soil_h%var_2d
+       DO  l = 0, 1
+          CALL wrd_write_string( 'lsm_start_index_h' )
+          WRITE ( 14 )  surf_lsm_h(l)%start_index
+
+          CALL wrd_write_string( 'lsm_end_index_h' )
+          WRITE ( 14 )  surf_lsm_h(l)%end_index
+
+          WRITE( dum, '(I1)')  l
+          CALL wrd_write_string( 'm_soil_h(' // dum // ')' )
+          WRITE ( 14 )  m_soil_h(l)%var_2d
+       ENDDO
 
        DO  l = 0, 3
@@ -6679,12 +6798,15 @@
        ENDDO
 
-       CALL wrd_write_string( 'lsm_start_index_h' )
-       WRITE ( 14 )  surf_lsm_h%start_index
-
-       CALL wrd_write_string( 'lsm_end_index_h' )
-       WRITE ( 14 )  surf_lsm_h%end_index
-
-       CALL wrd_write_string( 'm_liq_h' )
-       WRITE ( 14 )  m_liq_h%var_1d
+       DO  l = 0, 1
+          CALL wrd_write_string( 'lsm_start_index_h' )
+          WRITE ( 14 )  surf_lsm_h(l)%start_index
+
+          CALL wrd_write_string( 'lsm_end_index_h' )
+          WRITE ( 14 )  surf_lsm_h(l)%end_index
+
+          WRITE( dum, '(I1)')  l
+          CALL wrd_write_string( 'm_liq_h(' // dum // ')' )
+          WRITE ( 14 )  m_liq_h(l)%var_1d
+       ENDDO
 
        DO  l = 0, 3
@@ -6702,12 +6824,15 @@
        ENDDO
 
-       CALL wrd_write_string( 'lsm_start_index_h' )
-       WRITE ( 14 )  surf_lsm_h%start_index
-
-       CALL wrd_write_string( 'lsm_end_index_h' )
-       WRITE ( 14 )  surf_lsm_h%end_index
-
-       CALL wrd_write_string( 't_surface_h' )
-       WRITE ( 14 )  t_surface_h%var_1d
+       DO  l = 0, 1
+          CALL wrd_write_string( 'lsm_start_index_h' )
+          WRITE ( 14 )  surf_lsm_h(l)%start_index
+
+          CALL wrd_write_string( 'lsm_end_index_h' )
+          WRITE ( 14 )  surf_lsm_h(l)%end_index
+
+          WRITE( dum, '(I1)')  l
+          CALL wrd_write_string( 't_surface_h(' // dum // ')' )
+          WRITE ( 14 )  t_surface_h(l)%var_1d
+       ENDDO
 
        DO  l = 0, 3
@@ -6738,14 +6863,22 @@
        IF ( ALLOCATED( t_soil_av ) )  CALL wrd_mpi_io( 't_soil_av', t_soil_av, nzb_soil, nzt_soil )
 
-       CALL rd_mpi_io_surface_filetypes( surf_lsm_h%start_index, surf_lsm_h%end_index,             &
-                                         surface_data_to_write, global_start_index )
-
-       CALL wrd_mpi_io( 'lsm_start_index_h',  surf_lsm_h%start_index )
-       CALL wrd_mpi_io( 'lsm_end_index_h',  surf_lsm_h%end_index )
-       CALL wrd_mpi_io( 'lsm_global_start_index_h', global_start_index )
-       CALL wrd_mpi_io_surface( 't_soil_h', t_soil_h%var_2d )
-       CALL wrd_mpi_io_surface( 'm_soil_h',  m_soil_h%var_2d )
-       CALL wrd_mpi_io_surface( 'm_liq_h', m_liq_h%var_1d )
-       CALL wrd_mpi_io_surface( 't_surface_h', t_surface_h%var_1d )
+       DO  l = 0, 1
+
+          WRITE( dum, '(I1)' )  l
+
+          CALL rd_mpi_io_surface_filetypes( surf_lsm_h(l)%start_index, surf_lsm_h(l)%end_index,             &
+                                            surface_data_to_write, global_start_index )
+
+          CALL wrd_mpi_io( 'lsm_start_index_h_' // dum,  surf_lsm_h(l)%start_index )
+          CALL wrd_mpi_io( 'lsm_end_index_h_' // dum,  surf_lsm_h(l)%end_index )
+          CALL wrd_mpi_io( 'lsm_global_start_index_h_' // dum, global_start_index )
+
+          IF ( .NOT. surface_data_to_write )  CYCLE
+
+          CALL wrd_mpi_io_surface( 't_soil_h(' // dum // ')', t_soil_h(l)%var_2d )
+          CALL wrd_mpi_io_surface( 'm_soil_h(' // dum // ')',  m_soil_h(l)%var_2d )
+          CALL wrd_mpi_io_surface( 'm_liq_h(' // dum // ')', m_liq_h(l)%var_1d )
+          CALL wrd_mpi_io_surface( 't_surface_h(' // dum // ')', t_surface_h(l)%var_1d )
+       ENDDO
 
        DO  l = 0, 3
@@ -6796,5 +6929,4 @@
     INTEGER(iwp) ::  k                 !<
     INTEGER(iwp) ::  l                 !< running index surface orientation
-    INTEGER(iwp) ::  ns_h_on_file_lsm  !< number of horizontal surface elements (natural type) on file
     INTEGER(iwp) ::  nxlc              !<
     INTEGER(iwp) ::  nxlf              !<
@@ -6810,4 +6942,5 @@
     INTEGER(iwp) ::  nys_on_file       !< index of south boundary on former local domain
 
+    INTEGER(iwp) ::  ns_h_on_file_lsm(0:1) !< number of horizontal surface elements (natural type) on file
     INTEGER(iwp) ::  ns_v_on_file_lsm(0:3) !< number of vertical surface elements (natural type) on file
 
@@ -6821,7 +6954,7 @@
     REAL(wp), DIMENSION(nzb_soil:nzt_soil,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: tmp_3d   !<
 
-    TYPE(surf_type_lsm), SAVE :: tmp_walltype_h_1d   !< temporary 1D array containing the respective surface variable stored on file, horizontal surfaces
-    TYPE(surf_type_lsm), SAVE :: tmp_walltype_h_2d   !< temporary 2D array containing the respective surface variable stored on file, horizontal surfaces
-    TYPE(surf_type_lsm), SAVE :: tmp_walltype_h_2d2  !< temporary 2D array containing the respective surface variable stored on file, horizontal surfaces
+    TYPE(surf_type_lsm), DIMENSION(0:1), SAVE :: tmp_walltype_h_1d   !< temporary 1D array containing the respective surface variable stored on file, horizontal surfaces
+    TYPE(surf_type_lsm), DIMENSION(0:1), SAVE :: tmp_walltype_h_2d   !< temporary 2D array containing the respective surface variable stored on file, horizontal surfaces
+    TYPE(surf_type_lsm), DIMENSION(0:1), SAVE :: tmp_walltype_h_2d2  !< temporary 2D array containing the respective surface variable stored on file, horizontal surfaces
 
     TYPE(surf_type_lsm), DIMENSION(0:3), SAVE :: tmp_walltype_v_1d   !< temporary 1D array containing the respective surface variable stored on file, vertical surfaces
@@ -6839,18 +6972,23 @@
              READ ( 13 ) ns_h_on_file_lsm
 
-             IF ( ALLOCATED( tmp_walltype_h_1d%var_1d ) )                      &
-                DEALLOCATE( tmp_walltype_h_1d%var_1d )
-             IF ( ALLOCATED( tmp_walltype_h_2d%var_2d ) )                      &
-                DEALLOCATE( tmp_walltype_h_2d%var_2d )
-             IF ( ALLOCATED( tmp_walltype_h_2d2%var_2d ) )                     &
-                DEALLOCATE( tmp_walltype_h_2d2%var_2d )
+             DO l = 0, 1
+                IF ( ALLOCATED( tmp_walltype_h_1d(l)%var_1d ) )                   &
+                   DEALLOCATE( tmp_walltype_h_1d(l)%var_1d )
+                IF ( ALLOCATED( tmp_walltype_h_2d(l)%var_2d ) )                   &
+                   DEALLOCATE( tmp_walltype_h_2d(l)%var_2d )
+                IF ( ALLOCATED( tmp_walltype_h_2d2(l)%var_2d ) )                  &
+                   DEALLOCATE( tmp_walltype_h_2d2(l)%var_2d )
+             ENDDO
 
 !
 !--          Allocate temporary arrays to store surface data
-             ALLOCATE( tmp_walltype_h_1d%var_1d(1:ns_h_on_file_lsm) )
-             ALLOCATE( tmp_walltype_h_2d%var_2d(nzb_soil:nzt_soil+1,           &
-                                                1:ns_h_on_file_lsm) )
-             ALLOCATE( tmp_walltype_h_2d2%var_2d(nzb_soil:nzt_soil,            &
-                       1:ns_h_on_file_lsm)  )
+             DO l = 0, 1
+                ALLOCATE( tmp_walltype_h_1d(l)                                    &
+                             %var_1d(1:ns_h_on_file_lsm(l)) )
+                ALLOCATE( tmp_walltype_h_2d(l)                                    &
+                             %var_2d(nzb_soil:nzt_soil+1, 1:ns_h_on_file_lsm(l)) )
+                ALLOCATE( tmp_walltype_h_2d2(l)                                   &
+                             %var_2d(nzb_soil:nzt_soil,1:ns_h_on_file_lsm(l))  )
+             ENDDO
 
           ENDIF
@@ -6991,16 +7129,36 @@
             ENDIF
 
-       CASE ( 't_soil_h' )
+       CASE ( 't_soil_h(0)' )
 
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_soil_h%var_2d ) )                        &
-                ALLOCATE( t_soil_h%var_2d(nzb_soil:nzt_soil+1,                 &
-                                          1:surf_lsm_h%ns) )
-             READ ( 13 )  tmp_walltype_h_2d%var_2d
+             IF ( .NOT.  ALLOCATED( t_soil_h(0)%var_2d ) )                     &
+                ALLOCATE( t_soil_h(0)%var_2d(nzb_soil:nzt_soil+1,              &
+                                          1:surf_lsm_h(0)%ns) )
+             READ ( 13 )  tmp_walltype_h_2d(0)%var_2d
           ENDIF
           CALL surface_restore_elements(                                       &
-                                     t_soil_h%var_2d,                          &
-                                     tmp_walltype_h_2d%var_2d,                 &
-                                     surf_lsm_h%start_index,                   &
+                                     t_soil_h(0)%var_2d,                       &
+                                     tmp_walltype_h_2d(0)%var_2d,              &
+                                     surf_lsm_h(0)%start_index,                &
+                                     start_index_on_file,                      &
+                                     end_index_on_file,                        &
+                                     nxlc, nysc,                               &
+                                     nxlf, nxrf, nysf, nynf,                   &
+                                     nys_on_file, nyn_on_file,                 &
+                                     nxl_on_file,nxr_on_file )
+
+       CASE ( 't_soil_h(1)' )
+
+          IF ( k == 1 )  THEN
+             IF ( .NOT.  ALLOCATED( t_soil_h(1)%var_2d ) )                     &
+                ALLOCATE( t_soil_h(1)%var_2d(nzb_soil:nzt_soil+1,              &
+                                          1:surf_lsm_h(1)%ns) )
+             write(9,*) surf_lsm_h(1)%ns
+             READ ( 13 )  tmp_walltype_h_2d(1)%var_2d
+          ENDIF
+          CALL surface_restore_elements(                                       &
+                                     t_soil_h(1)%var_2d,                       &
+                                     tmp_walltype_h_2d(1)%var_2d,              &
+                                     surf_lsm_h(1)%start_index,                &
                                      start_index_on_file,                      &
                                      end_index_on_file,                        &
@@ -7086,16 +7244,35 @@
                                   nxl_on_file,nxr_on_file )
 
-       CASE ( 'm_soil_h' )
+       CASE ( 'm_soil_h(0)' )
 
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( m_soil_h%var_2d ) )                        &
-                ALLOCATE( m_soil_h%var_2d(nzb_soil:nzt_soil+1,                 &
-                                          1:surf_lsm_h%ns) )
-             READ ( 13 )  tmp_walltype_h_2d2%var_2d
+             IF ( .NOT.  ALLOCATED( m_soil_h(0)%var_2d ) )                     &
+                ALLOCATE( m_soil_h(0)%var_2d(nzb_soil:nzt_soil+1,              &
+                                          1:surf_lsm_h(0)%ns) )
+             READ ( 13 )  tmp_walltype_h_2d2(0)%var_2d
           ENDIF
           CALL surface_restore_elements(                                       &
-                                    m_soil_h%var_2d,                           &
-                                    tmp_walltype_h_2d2%var_2d,                 &
-                                    surf_lsm_h%start_index,                    &
+                                    m_soil_h(0)%var_2d,                        &
+                                    tmp_walltype_h_2d2(0)%var_2d,              &
+                                    surf_lsm_h(0)%start_index,                 &
+                                    start_index_on_file,                       &
+                                    end_index_on_file,                         &
+                                    nxlc, nysc,                                &
+                                    nxlf, nxrf, nysf, nynf,                    &
+                                    nys_on_file, nyn_on_file,                  &
+                                    nxl_on_file,nxr_on_file )
+
+       CASE ( 'm_soil_h(1)' )
+
+          IF ( k == 1 )  THEN
+             IF ( .NOT.  ALLOCATED( m_soil_h(1)%var_2d ) )                     &
+                ALLOCATE( m_soil_h(1)%var_2d(nzb_soil:nzt_soil+1,              &
+                                          1:surf_lsm_h(1)%ns) )
+             READ ( 13 )  tmp_walltype_h_2d2(1)%var_2d
+          ENDIF
+          CALL surface_restore_elements(                                       &
+                                    m_soil_h(1)%var_2d,                        &
+                                    tmp_walltype_h_2d2(1)%var_2d,              &
+                                    surf_lsm_h(1)%start_index,                 &
                                     start_index_on_file,                       &
                                     end_index_on_file,                         &
@@ -7184,15 +7361,33 @@
 
 
-       CASE ( 'm_liq_h' )
+       CASE ( 'm_liq_h(0)' )
 
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( m_liq_h%var_1d ) )                         &
-                ALLOCATE( m_liq_h%var_1d(1:surf_lsm_h%ns) )
-             READ ( 13 )  tmp_walltype_h_1d%var_1d
+             IF ( .NOT.  ALLOCATED( m_liq_h(0)%var_1d ) )                      &
+                ALLOCATE( m_liq_h(0)%var_1d(1:surf_lsm_h(0)%ns) )
+             READ ( 13 )  tmp_walltype_h_1d(0)%var_1d
           ENDIF
           CALL surface_restore_elements(                                       &
-                                     m_liq_h%var_1d,                           &
-                                     tmp_walltype_h_1d%var_1d,                 &
-                                     surf_lsm_h%start_index,                   &
+                                     m_liq_h(0)%var_1d,                        &
+                                     tmp_walltype_h_1d(0)%var_1d,              &
+                                     surf_lsm_h(0)%start_index,                &
+                                     start_index_on_file,                      &
+                                     end_index_on_file,                        &
+                                     nxlc, nysc,                               &
+                                     nxlf, nxrf, nysf, nynf,                   &
+                                     nys_on_file, nyn_on_file,                 &
+                                     nxl_on_file,nxr_on_file )
+
+       CASE ( 'm_liq_h(1)' )
+
+          IF ( k == 1 )  THEN
+             IF ( .NOT.  ALLOCATED( m_liq_h(1)%var_1d ) )                      &
+                ALLOCATE( m_liq_h(1)%var_1d(1:surf_lsm_h(1)%ns) )
+             READ ( 13 )  tmp_walltype_h_1d(1)%var_1d
+          ENDIF
+          CALL surface_restore_elements(                                       &
+                                     m_liq_h(1)%var_1d,                        &
+                                     tmp_walltype_h_1d(1)%var_1d,              &
+                                     surf_lsm_h(1)%start_index,                &
                                      start_index_on_file,                      &
                                      end_index_on_file,                        &
@@ -7278,15 +7473,33 @@
 
 
-       CASE ( 't_surface_h' )
+       CASE ( 't_surface_h(0)' )
 
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surface_h%var_1d ) )                     &
-                ALLOCATE( t_surface_h%var_1d(1:surf_lsm_h%ns) )
-             READ ( 13 )  tmp_walltype_h_1d%var_1d
+             IF ( .NOT.  ALLOCATED( t_surface_h(0)%var_1d ) )                  &
+                ALLOCATE( t_surface_h(0)%var_1d(1:surf_lsm_h(0)%ns) )
+             READ ( 13 )  tmp_walltype_h_1d(0)%var_1d
           ENDIF
           CALL surface_restore_elements(                                       &
-                                     t_surface_h%var_1d,                       &
-                                     tmp_walltype_h_1d%var_1d,                 &
-                                     surf_lsm_h%start_index,                   &
+                                     t_surface_h(0)%var_1d,                    &
+                                     tmp_walltype_h_1d(0)%var_1d,              &
+                                     surf_lsm_h(0)%start_index,                &
+                                     start_index_on_file,                      &
+                                     end_index_on_file,                        &
+                                     nxlc, nysc,                               &
+                                     nxlf, nxrf, nysf, nynf,                   &
+                                     nys_on_file, nyn_on_file,                 &
+                                     nxl_on_file,nxr_on_file )
+
+       CASE ( 't_surface_h(1)' )
+
+          IF ( k == 1 )  THEN
+             IF ( .NOT.  ALLOCATED( t_surface_h(1)%var_1d ) )                  &
+                ALLOCATE( t_surface_h(1)%var_1d(1:surf_lsm_h(1)%ns) )
+             READ ( 13 )  tmp_walltype_h_1d(1)%var_1d
+          ENDIF
+          CALL surface_restore_elements(                                       &
+                                     t_surface_h(1)%var_1d,                    &
+                                     tmp_walltype_h_1d(1)%var_1d,              &
+                                     surf_lsm_h(1)%start_index,                &
                                      start_index_on_file,                      &
                                      end_index_on_file,                        &
@@ -7466,16 +7679,20 @@
     ENDIF
 
-    CALL rrd_mpi_io( 'lsm_start_index_h',  surf_lsm_h%start_index )
-    CALL rrd_mpi_io( 'lsm_end_index_h',  surf_lsm_h%end_index )
-    CALL rrd_mpi_io( 'lsm_global_start_index_h', global_start )
-
-    CALL rd_mpi_io_surface_filetypes ( surf_lsm_h%start_index, surf_lsm_h%end_index, ldum,         &
-                                       global_start )
-
-    CALL rrd_mpi_io_surface( 't_soil_h', t_soil_h%var_2d )
-    CALL rrd_mpi_io_surface( 'm_soil_h',  m_soil_h%var_2d )
-    CALL rrd_mpi_io_surface( 'm_liq_h', m_liq_h%var_1d )
-    CALL rrd_mpi_io_surface( 't_surface_h', t_surface_h%var_1d )
-
+    DO l = 0, 1
+
+       WRITE( dum, '(I1)')  l
+
+       CALL rrd_mpi_io( 'lsm_start_index_h_' // dum,  surf_lsm_h(l)%start_index )
+       CALL rrd_mpi_io( 'lsm_end_index_h_' // dum,  surf_lsm_h(l)%end_index )
+       CALL rrd_mpi_io( 'lsm_global_start_index_h_' // dum, global_start )
+
+       CALL rd_mpi_io_surface_filetypes ( surf_lsm_h(l)%start_index, surf_lsm_h(l)%end_index, ldum,         &
+                                          global_start )
+
+       CALL rrd_mpi_io_surface( 't_soil_h(' // dum // ')', t_soil_h(l)%var_2d )
+       CALL rrd_mpi_io_surface( 'm_soil_h(' // dum // ')',  m_soil_h(l)%var_2d )
+       CALL rrd_mpi_io_surface( 'm_liq_h(' // dum // ')', m_liq_h(l)%var_1d )
+       CALL rrd_mpi_io_surface( 't_surface_h(' // dum // ')', t_surface_h(l)%var_1d )
+    ENDDO
 
     DO  l = 0, 3
@@ -7531,10 +7748,10 @@
 !       REAL(wp) :: re_0 !< near-surface roughness Reynolds number
 
-       DO  m = 1, surf_lsm_h%ns
-
-          i   = surf_lsm_h%i(m)
-          j   = surf_lsm_h%j(m)
-
-          IF ( surf_lsm_h%water_surface(m) )  THEN
+       DO  m = 1, surf_lsm_h(0)%ns
+!--       only upward facin horizontal surfaces are considered for water surface processing
+          i   = surf_lsm_h(0)%i(m)
+          j   = surf_lsm_h(0)%j(m)
+
+          IF ( surf_lsm_h(0)%water_surface(m) )  THEN
 
 !
@@ -7563,26 +7780,26 @@
 !--          Charnock relation is used. Add a security factor of 1E-8 to avoid
 !--          divisions by zero.
-             surf_lsm_h%z0(m)  = ( 0.11_wp * molecular_viscosity /             &
-                                 ( surf_lsm_h%us(m) + 1E-8_wp ) )              &
-                               + ( alpha_ch * surf_lsm_h%us(m)**2 / g )
-
-             surf_lsm_h%z0h(m) = 0.40_wp * molecular_viscosity /               &
-                                 ( surf_lsm_h%us(m) + 1E-8_wp )
-             surf_lsm_h%z0q(m) = 0.62_wp * molecular_viscosity /               &
-                                 ( surf_lsm_h%us(m) + 1E-8_wp )
-
-
-             IF ( surf_lsm_h%z0(m) > 0.1_wp * surf_lsm_h%z_mo(m) )  THEN
-                surf_lsm_h%z0(m) = 0.1_wp * surf_lsm_h%z_mo(m)
+             surf_lsm_h(0)%z0(m)  = ( 0.11_wp * molecular_viscosity /             &
+                                 ( surf_lsm_h(0)%us(m) + 1E-8_wp ) )              &
+                               + ( alpha_ch * surf_lsm_h(0)%us(m)**2 / g )
+
+             surf_lsm_h(0)%z0h(m) = 0.40_wp * molecular_viscosity /               &
+                                 ( surf_lsm_h(0)%us(m) + 1E-8_wp )
+             surf_lsm_h(0)%z0q(m) = 0.62_wp * molecular_viscosity /               &
+                                 ( surf_lsm_h(0)%us(m) + 1E-8_wp )
+
+
+             IF ( surf_lsm_h(0)%z0(m) > 0.1_wp * surf_lsm_h(0)%z_mo(m) )  THEN
+                surf_lsm_h(0)%z0(m) = 0.1_wp * surf_lsm_h(0)%z_mo(m)
                 flag_exceed_z0   = .TRUE.
              ENDIF
 
-             IF ( surf_lsm_h%z0h(m) >= 0.1_wp * surf_lsm_h%z_mo(m) )  THEN
-                surf_lsm_h%z0h(m) = 0.1_wp * surf_lsm_h%z_mo(m)
+             IF ( surf_lsm_h(0)%z0h(m) >= 0.1_wp * surf_lsm_h(0)%z_mo(m) )  THEN
+                surf_lsm_h(0)%z0h(m) = 0.1_wp * surf_lsm_h(0)%z_mo(m)
                 flag_exceed_z0h   = .TRUE.
              ENDIF
 
-             IF ( surf_lsm_h%z0q(m) >= 0.1_wp * surf_lsm_h%z_mo(m) )  THEN
-                surf_lsm_h%z0q(m) = 0.1_wp * surf_lsm_h%z_mo(m)
+             IF ( surf_lsm_h(0)%z0q(m) >= 0.1_wp * surf_lsm_h(0)%z_mo(m) )  THEN
+                surf_lsm_h(0)%z0q(m) = 0.1_wp * surf_lsm_h(0)%z_mo(m)
                 flag_exceed_z0h   = .TRUE.
              ENDIF
